<?php
class security {
	public $password;
	
	function set_password($password) {
		return $this->password = $password;
	}
	
	function md5_encrypt($plain_text, $iv_len = 16) {
		$password = $this->password;
		$plain_text .= "\x13";
		$n = strlen ( $plain_text );
		if ($n % 16)
			$plain_text .= str_repeat ( "\0", 16 - ($n % 16) );
		$i = 0;
		$enc_text = $this->get_rnd_iv ( $iv_len );
		$iv = substr ( $password ^ $enc_text, 0, 512 );
		while ( $i < $n ) {
			$block = substr ( $plain_text, $i, 16 ) ^ pack ( 'H*', md5 ( $iv ) );
			$enc_text .= $block;
			$iv = substr ( $block . $iv, 0, 512 ) ^ $password;
			$i += 16;
		}
		return base64_encode ( $enc_text );
	}
	
	function md5_decrypt($enc_text, $iv_len = 16) {
		$password = $this->password;
		$enc_text = base64_decode ( $enc_text );
		$n = strlen ( $enc_text );
		$i = $iv_len;
		$plain_text = '';
		$iv = substr ( $password ^ substr ( $enc_text, 0, $iv_len ), 0, 512 );
		while ( $i < $n ) {
			$block = substr ( $enc_text, $i, 16 );
			$plain_text .= $block ^ pack ( 'H*', md5 ( $iv ) );
			$iv = substr ( $block . $iv, 0, 512 ) ^ $password;
			$i += 16;
		}
		return preg_replace ( '/\\x13\\x00*$/', '', $plain_text );
	}
	
	function get_rnd_iv($iv_len) {
		$iv = '';
		while ( $iv_len -- > 0 ) {
			$iv .= chr ( mt_rand () & 0xff );
		}
		return $iv;
	}

}

$security = new security ();

?>