<?php

class file {
	function download_file(&$stemp, $local_file, $download_file) {
		
		if (file_exists ( $local_file ) && is_file ( $local_file )) {
			header ( 'Cache-control: private' );
			header ( 'Content-Type: application/octet-stream' );
			header ( 'Content-Length: ' . filesize ( $local_file ) );
			header ( 'Content-Disposition: filename=' . $download_file );
			flush ();
			$file = fopen ( $local_file, "rb" );
			print fread ( $file, filesize ( $local_file ) );
			fclose ( $file );
		} else {
			$stemp->trigger_error ( _ ( 'Error: The file ' . $local_file . ' does not exist!' ) );
		}
	}
	
	function download_speedlimit(&$stemp, $local_file, $download_file, $download_rate = 30) {
		
		if (file_exists ( $local_file ) && is_file ( $local_file )) {
			// send headers
			header ( 'Cache-control: private' );
			header ( 'Content-Type: application/octet-stream' );
			header ( 'Content-Length: ' . filesize ( $local_file ) );
			header ( 'Content-Disposition: filename=' . $download_file );
			
			flush ();
			$file = fopen ( $local_file, "r" );
			while ( ! feof ( $file ) ) {
				print fread ( $file, round ( $download_rate * 1024 ) );
				flush ();
				sleep ( 1 );
			}
			fclose ( $file );
		} else {
			$stemp->trigger_error ( _ ( 'Error: The file ' . $local_file . ' does not exist!' ) );
		}
	}
}

$file = new file ()?>

