<?php

header ( 'Content-Type: text/html; charset=utf-8' );

define ( 'ROOTDIR', dirname ( __FILE__ ) );
define ( 'PLUGINS_PATH', ROOTDIR . '/plugins/' );
define ( 'CACHE_PATH', ROOTDIR . '/cache/' );


include (ROOTDIR . "/includes/stemp_class.php");

$stemp = new stemp ();

$stemp->enable_debug();

foreach ( $stemp->plugins as $key => $value ) {
	
	if(!is_array($value)){
		$stemp->trigger_error ( "The custom plugin named $value has been incorrectly configured" ) ;
	}

	if (!$value['path']){
		continue;
	}
	
	$file = $value['path'] . $value['filename'] .".php";
	
	if (file_exists ( $file )) {
		include ($file);
	} else {
		$stemp->trigger_error  ( "The custom plugin named $value could not be included" ) ;
	}
}

?>